<div>
  <h1 align="center">Karim</h1>
  <h3 align="center">Graphical interface for command-line tool youtube-dl.</h3>
</div>

<br/>

<p align="center">
   <a href="https://github.com/robertsanseries/karim/blob/master/LICENSE">
    <img src="https://img.shields.io/badge/License-GPL--3.0-blue.svg">
   </a>
   <a href="https://github.com/robertsanseries/karim/releases">
    <img src="https://img.shields.io/badge/Release-v%200.1.0-orange.svg">
   </a>
   <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=JXCBLTC8CDXN4">
     <img src="https://img.shields.io/badge/PayPal-%20To donate-red.svg">
    </a>
    <a href="https://github.com/robertsanseries/karim/releases/download/0.1.0/karimApp-0.1.0.deb">
     <img src="https://img.shields.io/badge/Download-%20Package .deb-yellow.svg">
    </a>
</p>

<br/>

<p align="center">
    <img width="700" height="500" src="https://raw.github.com/robertsanseries/karim/master/data/images/screenshot.png" alt="Screenshot">
</p>

<p align="center">
    <img width="700" height="500" src="https://raw.github.com/robertsanseries/karim/master/data/images/screenshot-2.png" alt="Screenshot">
</p>

<h2> </h2>

<p align="center">
   <img src="https://raw.github.com/robertsanseries/karim/master/data/images/com.github.robertsanseries.karim.png">
</p>

<p align="center"> Download your favorite videos! </p>

Karim is a graphical interface to the youtube-dl command-line tool. Built from the ground up for the elementary operating system.

### Downloader for YouTube, Vimeo and other sites.
The Karim helps you to save bandwidth. Download one time and playback anytime everywhere!


### Features
- [x] Automatic download of youtube-dl.
- [x] Support for simultaneous downloads of multiple videos.
- [X] Support for playlist download options.
- [ ] Video to mp3 audio conversion.
- [ ] Possibility to choose video format.
- [ ] Authentication for downloading videos.

<p align="center">
  <a href="https://github.com/robertsanseries/karim/issues/new"> Report a problem! </a>
</p>

## Installation

Unfortunately karim was rejected from AppCenter ([read more](https://github.com/robertsanseries/karim/issues/21)).

So there are four ways to get karim

1 - [Click here to download it in .deb format](https://github.com/robertsanseries/karim/releases/download/0.1.0/karimApp-0.1.0.deb)

2 - [Click here to download it in zip format](https://github.com/robertsanseries/karim/archive/0.1.0.zip)

3 - [Click here to download it in .tar.gz format](https://github.com/robertsanseries/karim/archive/0.1.0.tar.gz)

4 - Clone the repository

## Dependencies
These dependencies must be present before building
 - `meson (>=0.40)`
 - `valac (>=0.16)`
 - `debhelper (>=9)`
 - `libgda-5.0`
 - `libgranite`
 - `libgtk-3`
 - `sqlite3`

## Building
```
meson build && cd build
mesonconf -Dprefix=/usr
ninja
sudo ninja install
```

## Deconstruct
```
sudo ninja uninstall
```

## Test and Development
```
cd src
valac --pkg libgda-5.0  --pkg gtk+-3.0 --pkg granite Karim.vala Core/Stylesheet.vala Core/Constants.vala Widgets/Toolbar.vala Widgets/Welcome.vala Widgets/AboutDialog.vala Utils/StringUtil.vala Utils/URLUtil.vala Utils/WidgetUtil.vala Views/DownloadsListView.vala  Views/KarimView.vala Views/WelcomeView.vala Core/Database.vala Views/DownloadsRowView.vala Widgets/Toast.vala Models/DownloadModel.vala Objects/Download.vala Utils/FileUtil.vala 
./Karim
```
